$(function() {
	var active = "";
	var projects = [];
	var pending = [];

	$("#projectGroup").resizable({
		ghost : false,
		handles : "e"
	});

	$("#pendingGroup").resizable({
		ghost : false,
		handles : "e"
	});

	$("#pendingGroup").resizable({
		resize : function(event, ui) {
			showPending(pending);
			$('#descTextArea').resize();
		}
	});

	$.getJSON('/projects', function(data) {
		$.each(data, function() {
			projects.push(this.name);
			var css = 'class="project-item ui-widget-content" '
			var id = ' id="' + this.name + '"'
			var icon = '<span class="glyphicon glyphicon-book"></span> '
			var link = '/work/' + this.name
			$('#projectList').append(
					'<li ' + css + id + '>' + icon + this.name + '</li>');
		});
	});

	$('#projectList').selectable({
		selecting : function(event, ui) {
			var c = $(event.target).children('.ui-selecting');
			c.not(':first').removeClass('ui-selecting');
		}
	});

	$('#projectList').selectable({
		stop : function() {
			$(".ui-selected", this).each(function() {
				var i = $("#projectList li").index(this);
				active = projects[i];
				buildPending(active);
			});
		}
	});

	function diffSummary(a, d) {
		var div = "";
		for (i = 0; i < 5; i++) {
			if (a > 0) {
				a--;
				div += '<div class="status-add"></div>';
			} else if (d > 0) {
				d--;
				div += '<div class="status-delete"></div>';
			} else {
				div += '<div class="status-empty"></div>';
			}
		}
		return div;
	}

	function buildPending(active) {
		pending = [];
		$.getJSON('/pending/' + active, function(data) {
			$.each(data, function() {
				pending.push(this);
			});
			showPending(pending);

			var l = pending.length;
			var text = "";
			if (l == 0)
				text = 'no changes';
			if (l > 0)
				text = l + ' change';
			if (l > 1)
				text += 's';
			$('#pendingCount').text(text);
		});
	}

	function showPending(pending) {

		var width = $('#pendingList').width();
		width = (width - 102) / 6.6;
		width = Math.floor(width);

		$('#pendingList').empty();
		if (pending.length == 0) {
			return;
		}

		$.each(pending, function(index) {
			var id = ' id="' + index + '"';
			var css = ' class="pending-item ui-widget-content" ';
			var value = ' value="' + this.path + '" ';
			var name = ' name="pending" ';
			var bars = diffSummary(this.add, this.del);

			var w = width;
			var path = this.path;
			if (path.length > w) {
				var a = Math.floor(w / 2);
				var b = w - a;
				var s = path.substr(0, a);
				var e = path.substr(path.length - (b - 1), b);
				path = s + '&hellip;' + e;
			}

			var pnd = '<span class="pending-path">' + path + '</span>';
			var stat = '<div class="status">' + bars + '</div>';

			$('#pendingList').append(
					'<fieldset' + id + css + '>' + '<input type="checkbox"'
							+ id + name + '>' + pnd + stat + '</fieldset>');
		});
	}

	$('#pendingList').selectable({
		filter : 'fieldset',
		stop : function() {
			$(".ui-selected", this).each(function() {
				var index = $(this).attr('id');
				var path = pending[index].path;

				buildDiff(active, path);
			});
		}
	});

	$('#pendingList').selectable({
		filter : 'fieldset',
		selecting : function(event, ui) {
			var c = $(event.target).children('.ui-selecting');
			c.not(':first').removeClass('ui-selecting');
		}
	});

	function buildDiff($active, $path) {
		$.post('/diff', {
			project : $active,
			path : $path
		}).done(
				function(data) {

					var editor = ace.edit("diffView");
					editor.setTheme("ace/theme/p4diff");
					editor.getSession().setMode("ace/mode/diff");
					editor.renderer.setOption('showLineNumbers', false);
					editor.setHighlightActiveLine(false);
					editor.setShowPrintMargin(false);
					editor.setReadOnly(true);
					editor.setValue(diffToString(data));

					var h = editor.getSession().getScreenLength()
							* editor.renderer.lineHeight
							+ editor.renderer.scrollBar.getWidth();

				//	$('#diffView').height("100%");
				//	$('#diffView').width("100%");
					editor.resize();
				});
	}

	function diffToString(diff) {
		var arr = $.parseJSON(diff);
		var str = "";
		for (i in arr) {
			str += arr[i] + "\n";
		}
		return str;
	}

	$("#submitButton").click(function() {
		var files = [];
		$.each($('input:checked'), function() {
			var i = $(this).attr('id');
			files.push(pending[i].path);
		});

		$.post('/submit', {
			project : active,
			'files' : files,
			description: $('#descTextArea').val()
		}).done(function(data) {

		});

	});

});